%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                                      %%
%%  ClientServer tool: dclient application                              %%
%%                                                                      %%
%%  (c) 2000 Universit catholique de Louvain.  All Rights Reserved.    %%
%%  The development of ClientServer is supported by the PIRATES project %%
%%  at the Universit catholique de Louvain.  This file is subject to   %%
%%  the general Mozart license.                                         %%
%%                                                                      %%
%%  Author: Peter Van Roy                                               %%
%%                                                                      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

functor
import Application Connection Module Pickle Fault QTk
define
   proc {LocalWatcher E FS W S}
      {Fault.installWatcher E FS W _}
      try 
	 {S}
      finally 
	 {Fault.deInstallWatcher E W _}
      end 
   end

   proc {Guard E FS S1 S2}
      N={NewName}
      T={Thread.this}
      proc {W E FS} {Thread.injectException T N} end 
   in 
      {Fault.enable E 'thread'(T) nil _}
      try 
	 {LocalWatcher E FS W S1}
      catch X then 
	 if X==N then 
	    {S2}
	 else 
	    raise X end 
	 end 
      end 
   end

   Args={Application.getCmdArgs
	 record('in'(single type:string)
		connect(single type:string))}

   UCell={NewCell Args.connect}
   PCell={NewCell unit}
   
   proc {TryToConnect FNURL}
      try
         Tick={Pickle.load FNURL}
         P={Connection.take Tick}
      in
         {Assign UCell FNURL}
         {Assign PCell P}
      catch _ then
         H R
         D=td(title:"Server is down!"
              action:proc {$} R=tryagain {W close} end
              td(label(init:"Please choose an option")
                 lrline(glue:we))
              td(padx:5 pady:5
                 button(text:"Try connecting again" glue:ew pady:5
                        action:proc {$} R=tryagain {W close} end)
                 lr(glue:ew pady:5
                    button(text:"Try connecting with new URL:"
                           action:proc {$} R=trynewurl({H get($)}) {W close} end)
                    entry(init:{Access UCell} handle:H))
                 button(text:"Keep trying forever" glue:ew pady:5
                        action:proc {$} R=tryforever {W close} end)
                 button(text:"Quit client" glue:ew
                        action:proc {$} R=quit {W close} end)))
         W={QTk.build D}
      in
         {W show}
         {Wait R}
         case R
         of tryagain then
            {TryToConnect FNURL}
         [] trynewurl(NewURL) then
            {TryToConnect NewURL}
         [] tryforever then
               D2=td(title:"Trying to reconnect with server..."
                     td(padx:50 pady:10
                        button(text:"Cancel trying to reconnect" glue:ew pady:10
                               action:toplevel#close)
                        button(text:"Quit client" glue:ew
                               action:proc {$} {Application.exit 0} end)))
               W2={QTk.build D2}
               GoOn={NewCell true}
               proc {LoopForever FNURL} 
                  {Delay 1000}
                  try
                     Tick={Pickle.load FNURL}
                     P={Connection.take Tick}
                  in
                     {Assign UCell FNURL}
                     {Assign PCell P}
                  catch _ then
                     if {Access GoOn} then {LoopForever FNURL}
                                      else {W2 close} {TryToConnect FNURL} end
                  end
                  {W2 close}
               end
            in
               thread {W2 show(wait:true)} {Assign GoOn false} end
               {LoopForever {Access UCell}}
         [] quit then
           {Application.exit 0}
         else skip end
      end
   end

   {TryToConnect {Access UCell}}

   [Client]={Module.link [Args.'in']}
   Q=Client.query

   proc {Q E R}
   Sync P U in
      {Fault.enable Sync 'thread'(this) nil _}
      U={Access UCell}
      P={Access PCell}
      {Guard P [permFail]
       proc {$}
	  {Send P E#R#Sync}
	  if Sync==unit then 
             skip 
          else 
             raise Sync end
          end
       end
       proc {$}
          {TryToConnect U}
          {Q E R}
       end}
   end
end

